// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int MAXN = 500;
int MAXC = MAXN;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	if (validator.group() == "1") {
		MAXN = 100; MAXC = 1;
	} else if (validator.group() == "2") {
		MAXN = 100; MAXC = 5;
	} else if (validator.group() == "3") {
		MAXN = 100; MAXC = MAXN;
	} else if (validator.group() == "4") {

	}

	int n = inf.readInt(1, MAXN, "n");
	inf.readEoln();

	vector<vector<char>> field(n, vector<char>(n));

	int centers = 0;

	for (int i = 0; i < n; ++i) {
		string s = inf.readLine();
		ensuref(szof(s) == n, "length should be %d", n);
		for (int j = 0; j < n; ++j) {
			char c = s[j];
			field[i][j] = c;
			ensuref(c == '.' || c == '+' || c == 'O', "bad symbol '%c'", c);
			if (c == 'O') {
				centers++;
			}
		}
	}

	ensuref(centers <= MAXC, "too many centers (%d/%d)", centers, MAXC);

	for (int i = 0; i < n; ++i) {
		int cnt = 0;
		for (int j = 0; j < n; ++j) {
			cnt += field[i][j] == 'O';
		}
		ensuref(cnt <= 1, "multiple centers in row %d", i + 1);

		cnt = 0;
		for (int j = 0; j < n; ++j) {
			cnt += field[j][i] == 'O';
		}

		ensuref(cnt <= 1, "multiple centers in column %d", i + 1);
	}

	inf.readEof();

	return 0;
}