// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> field(n, vector<int>(n));
	vector<vector<int>> is_center(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < n; ++j) {
			if (s[j] == 'O') {
				is_center[i][j] = 1;
			}
			if (s[j] == '+') {
				field[i][j] = 1;
			}
		}
	}

	vector<vector<pii>> nodes(n, vector<pii>(n, {-1, -1}));
	vector<vector<int>> hor(n, vector<int>(n, -1)), hor2(n, vector<int>(n, -1));
	vector<vector<int>> ver(n, vector<int>(n, -1)), ver2(n, vector<int>(n, -1));

	int cnt = 0;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (field[i][j]) {
				nodes[i][j].ff = cnt++;
				nodes[i][j].ss = cnt++;
				ver[i][j] = cnt++;
				hor[i][j] = cnt++;
				ver2[i][j] = cnt++;
				hor2[i][j] = cnt++;
			}
		}
	}

	vector<vector<int>> graph(cnt);
	vector<vector<bool>> reachable_hor(n, vector<bool>(n)), reachable_ver(n, vector<bool>(n));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (field[i][j]) {
				graph[hor[i][j]].push_back(nodes[i][j].ss);
				graph[ver[i][j]].push_back(nodes[i][j].ff);
				graph[nodes[i][j].ss].push_back(ver2[i][j]);
				graph[nodes[i][j].ff].push_back(hor2[i][j]);
			}
			if (is_center[i][j]) {
				for (int k = i - 1; k >= 0 && field[k][j]; --k) {
					if (ver[k + 1][j] != -1) {
						graph[ver[k][j]].push_back(ver[k + 1][j]);
						graph[ver2[k + 1][j]].push_back(ver2[k][j]);
					}
					reachable_ver[k][j] = true;
				}
				for (int k = i + 1; k < n && field[k][j]; ++k) {
					if (ver[k - 1][j] != -1) {
						graph[ver[k][j]].push_back(ver[k - 1][j]);
						graph[ver2[k - 1][j]].push_back(ver2[k][j]);
					}
					reachable_ver[k][j] = true;
				}

				for (int k = j - 1; k >= 0 && field[i][k]; --k) {
					if (hor[i][k + 1] != -1) {
						graph[hor[i][k]].push_back(hor[i][k + 1]);
						graph[hor2[i][k + 1]].push_back(hor2[i][k]);
					}
					reachable_hor[i][k] = true;
				}
				for (int k = j + 1; k < n && field[i][k]; ++k) {
					if (hor[i][k - 1] != -1) {
						graph[hor[i][k]].push_back(hor[i][k - 1]);
						graph[hor2[i][k - 1]].push_back(hor2[i][k]);
					}
					reachable_hor[i][k] = true;
				}
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (!field[i][j]) {
				continue;
			}
			if (!reachable_hor[i][j] && !reachable_ver[i][j]) {
				cout << "No\n";
				return;
			}
			if (!reachable_hor[i][j]) {
				graph[nodes[i][j].ss].push_back(nodes[i][j].ff);
			} else {
				graph[nodes[i][j].ss].push_back(hor[i][j]);
				graph[hor2[i][j]].push_back(nodes[i][j].ff);
			}

			if (!reachable_ver[i][j]) {
				graph[nodes[i][j].ff].push_back(nodes[i][j].ss);
			} else {
				graph[nodes[i][j].ff].push_back(ver[i][j]);
				graph[ver2[i][j]].push_back(nodes[i][j].ss);
			}
		}
	}

	// for (int i = 0; i < cnt; ++i) {
	// 	for (int to : graph[i]) {
	// 		cerr << i << " -> " << to << endl;
	// 	}
	// }

	vector<bool> used(cnt);

	function<void(int, vector<vector<int>> const&, vector<int>&)> dfs = [&](int v, vector<vector<int>> const& g, vector<int>& arr) {
		used[v] = true;
		for (int to : g[v]) {
			if (!used[to]) {
				dfs(to, g, arr);
			}
		}
		arr.push_back(v);
	};

	vector<int> order;

	for (int i = 0; i < cnt; ++i) {
		if (!used[i]) {
			dfs(i, graph, order);
		}
	}

	reverse(order.begin(), order.end());
	fill(used.begin(), used.end(), 0);

	vector<vector<int>> rgraph(cnt);
	for (int i = 0; i < cnt; ++i) {
		for (int to : graph[i]) {
			rgraph[to].push_back(i);
		}
	}

	vector<int> cur;
	int cur_color = 0;
	vector<int> color(cnt);
	for (int v : order) {
		if (!used[v]) {
			cur.clear();
			dfs(v, rgraph, cur);
			for (int u : cur) {
				color[u] = cur_color;
			}
			++cur_color;
		}
	}

	vector<vector<char>> ans(n, vector<char>(n, '.'));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (is_center[i][j]) {
				ans[i][j] = 'O';
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (field[i][j]) {
				if (color[nodes[i][j].ff] == color[nodes[i][j].ss]) {
					cout << "No\n";
					return;
				}
				if (color[nodes[i][j].ff] < color[nodes[i][j].ss]) {
					ans[i][j] = '-';
				} else {
					ans[i][j] = '|';
				}
			}
		}
	}

	cout << "Yes\n";

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cout << ans[i][j];
		}
		cout << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}